package com.migeran.moe.ui;

import org.moe.natj.general.Pointer;
import org.moe.natj.general.ann.Owned;
import org.moe.natj.general.ann.RegisterOnStartup;
import org.moe.natj.objc.ObjCRuntime;
import org.moe.natj.objc.ann.ObjCClassName;
import org.moe.natj.objc.ann.Property;
import org.moe.natj.objc.ann.Selector;

import apple.NSObject;
import apple.foundation.NSInputStream;
import apple.foundation.NSMutableSet;
import apple.foundation.NSOutputStream;
import apple.foundation.NSSet;
import apple.foundation.NSUserActivity;
import apple.foundation.protocol.NSUserActivityDelegate;
import apple.uikit.UIButton;
import apple.uikit.UILabel;
import apple.uikit.UIViewController;

@org.moe.natj.general.ann.Runtime(ObjCRuntime.class)
@ObjCClassName("AppViewController")
@RegisterOnStartup
public class AppViewController extends UIViewController implements NSUserActivityDelegate {

    @Owned
    @Selector("alloc")
    public static native AppViewController alloc();

    @Selector("init")
    public native AppViewController init();

    protected AppViewController(Pointer peer) {
        super(peer);
    }

    private NSUserActivity activity;

    @Override
    public void viewDidLoad() {
        super.viewDidLoad();

        activity = NSUserActivity.alloc().initWithActivityType("com.migeran.moe.ifaddrs.song");
        NSMutableSet<String> keywords = (NSMutableSet<String>) NSMutableSet.alloc().init();
        keywords.addObject("roland");
        keywords.addObject("vigh roland");
        activity.setTitle("roland");
        activity.setKeywords(keywords);
        activity.setEligibleForHandoff(true);
        activity.setEligibleForSearch(true);
        activity.setEligibleForPublicIndexing(true);
        activity.setDelegate(this);
        setUserActivity(activity);
        userActivity().becomeCurrent();

        System.out.println("Set activity: ok");
    }

    @Override
    public void userActivityDidReceiveInputStreamOutputStream(NSUserActivity userActivity, NSInputStream inputStream, NSOutputStream outputStream) {
        System.out.println("userActivityDidReceiveInputStreamOutputStream");
    }

    @Override
    public void userActivityWasContinued(NSUserActivity userActivity) {
        System.out.println("userActivityWasContinued");
    }

    @Override
    public void userActivityWillSave(NSUserActivity userActivity) {
        System.out.println("userActivityWillSave");
    }
}
